

public class MyLList {
    
    static class Node {
        public Node left,right;
        public Object data;
        public Node(Object d,Node l,Node r){
            data = d;
            left = l;
            right = r;
        }
    }

    Node lst;

    public MyLList(){
        lst = new Node(null,null,null);
        lst.left = lst.right = lst;
    }

    public boolean isEmpty(){
        return lst == lst.left;
    }

    public void push(Object o){
        Node a = new Node(o,lst,lst.right);
        a.right.left = a;
        a.left.right = a;
    }
    public Object pop(){
        if(isEmpty())
            return null;
        Object o = lst.right.data;
        lst.right = lst.right.right;
        lst.right.left = lst;
        return o;
    }
    public Object shift(){
        if(isEmpty())
            return null;
        Object o = lst.left.data;
        lst.left = lst.left.left;
        lst.left.right = lst;
        return o;        
    }
    
    public int size(){
        Node p = lst.right;
        int i=0;
        while(p != lst){
            p = p.right;
            i++;
        }
        return i;  
    }

    public Object get(int n){
        Node p = lst.right;
        for(int i=0;i<n;i++){
            p = p.right;
        }
        return p.data;
    }

    public String toString(){
        Node p = lst.right;
        String s = "[";
        while(p != lst){
            s += ""+p.data+",";
            p = p.right;
        }
        return s+"]";
    }
    
    public static void main(String[] args) throws Throwable {
        MyLList lst = new MyLList();
        for(int i=0;i<7;i++){
            lst.push(i*i);
            System.out.println("push: "+(i*i)+": lst:"+lst+"; size: "+lst.size());
        }
        
        for(int i=0;i<8;i++){
            System.out.println("["+i+"]: "+lst.get(i));
        }

        while(!lst.isEmpty()){
            Object o = lst.shift();
            System.out.println("shift: "+o+"; lst:"+lst);
        }
    }

}
