
public class MyList {
    
    Object[] arr;
    int head,tail;
    public MyList(int siz){
        arr = new Object[siz+1];
        head = tail = 0;
    }
    public boolean isEmpty(){
        return head == tail;
    }
    // [1,2,3] push 7, will result in [1,2,3,7]
    public void push(Object n){
        arr[head] = n;
        head = (head + 1) % arr.length;
    }

    // [1,2,3] pop will result in 3, leaving [1,2];
    public Object pop(){
        head = (arr.length + head - 1) % arr.length;
        return arr[head];
    }

    // [1,2,3] shift will result in 1, leaving [2,3];
    public Object shift(){
        Object n = arr[tail];
        tail = (tail + 1) % arr.length;
        return n;
    }
    // [1,2,3] unshift 7, will result in [7,1,2,3]
    public void unshift(Object n){
        tail = (arr.length + tail - 1) % arr.length;
        arr[tail] = n;
    }

    // get the ith element in list.
    // [1,2,3], 2nd element is 2.
    public Object get(int i){
        return arr[(tail + i) % arr.length];
    }

    // sets ith element.
    public void set(int i,Object n){
        arr[(tail + i) % arr.length] = n;
    }

    public int size(){
        return ((arr.length + head) - tail) % arr.length;
    }

    public String toString(){
        if(isEmpty())
            return "[]";
        String out = "[";
        for(int i=0;i<size()-1;i++){
            out += ""+get(i)+",";
        }
        out += ""+get(size()-1)+"]";
        return out;
    }

    public static void main(String[] args){
        System.out.println("Hello World!");

        MyList l = new MyList(20);
        
        for(int i=0;i<15;i++){
            l.push(Math.random() < 0.5 ? new MyList(20) : ""+Math.random());
        }
        System.out.println("list is: "+l);
    }
}

